/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * Modify at your own risk.
 */

package com.google.api.services.adsdatahub.v1.model;

/**
 * Request to add a constraint to a frequency-based user list.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Ads Data Hub API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class AddEventMatchersRequest extends com.google.api.client.json.GenericJson {

  /**
   * Contain only those constraints to add to the user list. The user list specified by user_list
   * should have none of the constraints specified here at the time of the call but can have other
   * pre-existing constraints.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<EventMatcher> eventMatchers;

  static {
    // hack to force ProGuard to consider EventMatcher used, since otherwise it would be stripped out
    // see https://github.com/google/google-api-java-client/issues/543
    com.google.api.client.util.Data.nullOf(EventMatcher.class);
  }

  /**
   * Contain only those constraints to add to the user list. The user list specified by user_list
   * should have none of the constraints specified here at the time of the call but can have other
   * pre-existing constraints.
   * @return value or {@code null} for none
   */
  public java.util.List<EventMatcher> getEventMatchers() {
    return eventMatchers;
  }

  /**
   * Contain only those constraints to add to the user list. The user list specified by user_list
   * should have none of the constraints specified here at the time of the call but can have other
   * pre-existing constraints.
   * @param eventMatchers eventMatchers or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public AddEventMatchersRequest setEventMatchers(java.util.List<EventMatcher> eventMatchers) {
    this.eventMatchers = eventMatchers;
    return this;
  }

  @Override
  public AddEventMatchersRequest set(String fieldName, Object value) {
    return (AddEventMatchersRequest) super.set(fieldName, value);
  }

  @Override
  public AddEventMatchersRequest clone() {
    return (AddEventMatchersRequest) super.clone();
  }

}
