/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * Modify at your own risk.
 */

package com.google.api.services.adsdatahub.v1.model;

/**
 * An Ads Data Hub customer.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Ads Data Hub API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class AdsDataCustomer extends com.google.api.client.json.GenericJson {

  /**
   * Name that uniquely identifies a customer. It should have the form
   * customers/[customer_id]/adsDataCustomers/[ads_data_customer_id], e.g.
   * 'customers/123/adsDataCustomers/456'.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String name;

  /**
   * Name that uniquely identifies a customer. It should have the form
   * customers/[customer_id]/adsDataCustomers/[ads_data_customer_id], e.g.
   * 'customers/123/adsDataCustomers/456'.
   * @return value or {@code null} for none
   */
  public java.lang.String getName() {
    return name;
  }

  /**
   * Name that uniquely identifies a customer. It should have the form
   * customers/[customer_id]/adsDataCustomers/[ads_data_customer_id], e.g.
   * 'customers/123/adsDataCustomers/456'.
   * @param name name or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public AdsDataCustomer setName(java.lang.String name) {
    this.name = name;
    return this;
  }

  @Override
  public AdsDataCustomer set(String fieldName, Object value) {
    return (AdsDataCustomer) super.set(fieldName, value);
  }

  @Override
  public AdsDataCustomer clone() {
    return (AdsDataCustomer) super.clone();
  }

}
