/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * Modify at your own risk.
 */

package com.google.api.services.adsdatahub.v1.model;

/**
 * Request to batch approve ads data links.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Ads Data Hub API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class BatchApproveAdsDataLinksRequest extends com.google.api.client.json.GenericJson {

  /**
   * Required. The resource names of the links to approve. A maximum of 100 links can be approved in
   * a batch.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.lang.String> names;

  /**
   * Required. The resource names of the links to approve. A maximum of 100 links can be approved in
   * a batch.
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.String> getNames() {
    return names;
  }

  /**
   * Required. The resource names of the links to approve. A maximum of 100 links can be approved in
   * a batch.
   * @param names names or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public BatchApproveAdsDataLinksRequest setNames(java.util.List<java.lang.String> names) {
    this.names = names;
    return this;
  }

  @Override
  public BatchApproveAdsDataLinksRequest set(String fieldName, Object value) {
    return (BatchApproveAdsDataLinksRequest) super.set(fieldName, value);
  }

  @Override
  public BatchApproveAdsDataLinksRequest clone() {
    return (BatchApproveAdsDataLinksRequest) super.clone();
  }

}
