/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * Modify at your own risk.
 */

package com.google.api.services.adsdatahub.v1.model;

/**
 * Response to a BatchUpdateAdsDataLinks request.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Ads Data Hub API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class BatchRejectAdsDataLinksResponse extends com.google.api.client.json.GenericJson {

  /**
   * Links updated.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<AdsDataLink> links;

  static {
    // hack to force ProGuard to consider AdsDataLink used, since otherwise it would be stripped out
    // see https://github.com/google/google-api-java-client/issues/543
    com.google.api.client.util.Data.nullOf(AdsDataLink.class);
  }

  /**
   * Links updated.
   * @return value or {@code null} for none
   */
  public java.util.List<AdsDataLink> getLinks() {
    return links;
  }

  /**
   * Links updated.
   * @param links links or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public BatchRejectAdsDataLinksResponse setLinks(java.util.List<AdsDataLink> links) {
    this.links = links;
    return this;
  }

  @Override
  public BatchRejectAdsDataLinksResponse set(String fieldName, Object value) {
    return (BatchRejectAdsDataLinksResponse) super.set(fieldName, value);
  }

  @Override
  public BatchRejectAdsDataLinksResponse clone() {
    return (BatchRejectAdsDataLinksResponse) super.clone();
  }

}
