/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * Modify at your own risk.
 */

package com.google.api.services.adsdatahub.v1.model;

/**
 * Represents a link between two Ads Data Hub customers.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Ads Data Hub API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class CustomerLink extends com.google.api.client.json.GenericJson {

  /**
   * Access types that are exposed through this link.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.lang.String> accessTypes;

  /**
   * Linked Ads Data Hub customer ID.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @com.google.api.client.json.JsonString
  private java.lang.Long customerId;

  /**
   * This field will only be set for inbound links. As the linked customer may or may not be
   * directly linked, this field indicates the customer the linked customer is directly linked to.
   * I.e. The current customer gets access to the linked customer through the indirect relationship
   * connected by the direct parent(s). E.g., if A manages B and B manages C, then C will be listed
   * as A's inbound link with its direct_parent_customer_id set to B. In the case of direct links,
   * it will include the customer ID of the current customer.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @com.google.api.client.json.JsonString
  private java.util.List<java.lang.Long> directParentCustomerIds;

  /**
   * Linked customer's display name.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String displayName;

  /**
   * Name that uniquely identifies an customer link. Inbound links have the form
   * customers/[customer_id]/inboundCustomerLinks/[linked_customer_id]. Outbound links have the form
   * customers/[customer_id]/outboundCustomerLinks/[linked_customer_id].
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String name;

  /**
   * Status of the customer link.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String status;

  /**
   * Time the link status was last updated.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String updateTime;

  /**
   * Access types that are exposed through this link.
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.String> getAccessTypes() {
    return accessTypes;
  }

  /**
   * Access types that are exposed through this link.
   * @param accessTypes accessTypes or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public CustomerLink setAccessTypes(java.util.List<java.lang.String> accessTypes) {
    this.accessTypes = accessTypes;
    return this;
  }

  /**
   * Linked Ads Data Hub customer ID.
   * @return value or {@code null} for none
   */
  public java.lang.Long getCustomerId() {
    return customerId;
  }

  /**
   * Linked Ads Data Hub customer ID.
   * @param customerId customerId or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public CustomerLink setCustomerId(java.lang.Long customerId) {
    this.customerId = customerId;
    return this;
  }

  /**
   * This field will only be set for inbound links. As the linked customer may or may not be
   * directly linked, this field indicates the customer the linked customer is directly linked to.
   * I.e. The current customer gets access to the linked customer through the indirect relationship
   * connected by the direct parent(s). E.g., if A manages B and B manages C, then C will be listed
   * as A's inbound link with its direct_parent_customer_id set to B. In the case of direct links,
   * it will include the customer ID of the current customer.
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.Long> getDirectParentCustomerIds() {
    return directParentCustomerIds;
  }

  /**
   * This field will only be set for inbound links. As the linked customer may or may not be
   * directly linked, this field indicates the customer the linked customer is directly linked to.
   * I.e. The current customer gets access to the linked customer through the indirect relationship
   * connected by the direct parent(s). E.g., if A manages B and B manages C, then C will be listed
   * as A's inbound link with its direct_parent_customer_id set to B. In the case of direct links,
   * it will include the customer ID of the current customer.
   * @param directParentCustomerIds directParentCustomerIds or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public CustomerLink setDirectParentCustomerIds(java.util.List<java.lang.Long> directParentCustomerIds) {
    this.directParentCustomerIds = directParentCustomerIds;
    return this;
  }

  /**
   * Linked customer's display name.
   * @return value or {@code null} for none
   */
  public java.lang.String getDisplayName() {
    return displayName;
  }

  /**
   * Linked customer's display name.
   * @param displayName displayName or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public CustomerLink setDisplayName(java.lang.String displayName) {
    this.displayName = displayName;
    return this;
  }

  /**
   * Name that uniquely identifies an customer link. Inbound links have the form
   * customers/[customer_id]/inboundCustomerLinks/[linked_customer_id]. Outbound links have the form
   * customers/[customer_id]/outboundCustomerLinks/[linked_customer_id].
   * @return value or {@code null} for none
   */
  public java.lang.String getName() {
    return name;
  }

  /**
   * Name that uniquely identifies an customer link. Inbound links have the form
   * customers/[customer_id]/inboundCustomerLinks/[linked_customer_id]. Outbound links have the form
   * customers/[customer_id]/outboundCustomerLinks/[linked_customer_id].
   * @param name name or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public CustomerLink setName(java.lang.String name) {
    this.name = name;
    return this;
  }

  /**
   * Status of the customer link.
   * @return value or {@code null} for none
   */
  public java.lang.String getStatus() {
    return status;
  }

  /**
   * Status of the customer link.
   * @param status status or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public CustomerLink setStatus(java.lang.String status) {
    this.status = status;
    return this;
  }

  /**
   * Time the link status was last updated.
   * @return value or {@code null} for none
   */
  public String getUpdateTime() {
    return updateTime;
  }

  /**
   * Time the link status was last updated.
   * @param updateTime updateTime or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public CustomerLink setUpdateTime(String updateTime) {
    this.updateTime = updateTime;
    return this;
  }

  @Override
  public CustomerLink set(String fieldName, Object value) {
    return (CustomerLink) super.set(fieldName, value);
  }

  @Override
  public CustomerLink clone() {
    return (CustomerLink) super.clone();
  }

}
