/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * Modify at your own risk.
 */

package com.google.api.services.adsdatahub.v1.model;

/**
 * Data access budget state per date.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Ads Data Hub API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class DataAccessBudget extends com.google.api.client.json.GenericJson {

  /**
   * Status of the budget by date.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<DataDayState> dataDayState;

  /**
   * Status of the budget by date.
   * @return value or {@code null} for none
   */
  public java.util.List<DataDayState> getDataDayState() {
    return dataDayState;
  }

  /**
   * Status of the budget by date.
   * @param dataDayState dataDayState or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public DataAccessBudget setDataDayState(java.util.List<DataDayState> dataDayState) {
    this.dataDayState = dataDayState;
    return this;
  }

  @Override
  public DataAccessBudget set(String fieldName, Object value) {
    return (DataAccessBudget) super.set(fieldName, value);
  }

  @Override
  public DataAccessBudget clone() {
    return (DataAccessBudget) super.clone();
  }

}
