/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * Modify at your own risk.
 */

package com.google.api.services.adsdatahub.v1.model;

/**
 * A record containing date and state of the budget for this date.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Ads Data Hub API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class DataDayState extends com.google.api.client.json.GenericJson {

  /**
   * State of the budget for this data date.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String budgetState;

  /**
   * Date of the data day corresponding to this record.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Date date;

  /**
   * State of the budget for this data date.
   * @return value or {@code null} for none
   */
  public java.lang.String getBudgetState() {
    return budgetState;
  }

  /**
   * State of the budget for this data date.
   * @param budgetState budgetState or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public DataDayState setBudgetState(java.lang.String budgetState) {
    this.budgetState = budgetState;
    return this;
  }

  /**
   * Date of the data day corresponding to this record.
   * @return value or {@code null} for none
   */
  public Date getDate() {
    return date;
  }

  /**
   * Date of the data day corresponding to this record.
   * @param date date or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public DataDayState setDate(Date date) {
    this.date = date;
    return this;
  }

  @Override
  public DataDayState set(String fieldName, Object value) {
    return (DataDayState) super.set(fieldName, value);
  }

  @Override
  public DataDayState clone() {
    return (DataDayState) super.clone();
  }

}
