/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * Modify at your own risk.
 */

package com.google.api.services.adsdatahub.v1.model;

/**
 * Request to describe valid DV360 Advertiser IDs
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Ads Data Hub API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class DescribeValidDv360AdvertiserIdsRequest extends com.google.api.client.json.GenericJson {

  /**
   * Required. Ads Data Owning customer's ID, e.g. 456.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @com.google.api.client.json.JsonString
  private java.lang.Long adsDataCustomerId;

  /**
   * Required. DV360 Partner ID whose Advertiser Ids are requested e.g. 1234 Note that this partner
   * must be linked to the ADH customer speciified by ads_data_customer_id
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @com.google.api.client.json.JsonString
  private java.lang.Long dv360PartnerId;

  /**
   * Maximum number of items to return. If 0, the server will determine the number of linked
   * customers to return.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Integer pageSize;

  /**
   * Page token, returned by a previous call, used to request the next page of results, if any.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String pageToken;

  /**
   * Required. Ads Data Owning customer's ID, e.g. 456.
   * @return value or {@code null} for none
   */
  public java.lang.Long getAdsDataCustomerId() {
    return adsDataCustomerId;
  }

  /**
   * Required. Ads Data Owning customer's ID, e.g. 456.
   * @param adsDataCustomerId adsDataCustomerId or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public DescribeValidDv360AdvertiserIdsRequest setAdsDataCustomerId(java.lang.Long adsDataCustomerId) {
    this.adsDataCustomerId = adsDataCustomerId;
    return this;
  }

  /**
   * Required. DV360 Partner ID whose Advertiser Ids are requested e.g. 1234 Note that this partner
   * must be linked to the ADH customer speciified by ads_data_customer_id
   * @return value or {@code null} for none
   */
  public java.lang.Long getDv360PartnerId() {
    return dv360PartnerId;
  }

  /**
   * Required. DV360 Partner ID whose Advertiser Ids are requested e.g. 1234 Note that this partner
   * must be linked to the ADH customer speciified by ads_data_customer_id
   * @param dv360PartnerId dv360PartnerId or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public DescribeValidDv360AdvertiserIdsRequest setDv360PartnerId(java.lang.Long dv360PartnerId) {
    this.dv360PartnerId = dv360PartnerId;
    return this;
  }

  /**
   * Maximum number of items to return. If 0, the server will determine the number of linked
   * customers to return.
   * @return value or {@code null} for none
   */
  public java.lang.Integer getPageSize() {
    return pageSize;
  }

  /**
   * Maximum number of items to return. If 0, the server will determine the number of linked
   * customers to return.
   * @param pageSize pageSize or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public DescribeValidDv360AdvertiserIdsRequest setPageSize(java.lang.Integer pageSize) {
    this.pageSize = pageSize;
    return this;
  }

  /**
   * Page token, returned by a previous call, used to request the next page of results, if any.
   * @return value or {@code null} for none
   */
  public java.lang.String getPageToken() {
    return pageToken;
  }

  /**
   * Page token, returned by a previous call, used to request the next page of results, if any.
   * @param pageToken pageToken or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public DescribeValidDv360AdvertiserIdsRequest setPageToken(java.lang.String pageToken) {
    this.pageToken = pageToken;
    return this;
  }

  @Override
  public DescribeValidDv360AdvertiserIdsRequest set(String fieldName, Object value) {
    return (DescribeValidDv360AdvertiserIdsRequest) super.set(fieldName, value);
  }

  @Override
  public DescribeValidDv360AdvertiserIdsRequest clone() {
    return (DescribeValidDv360AdvertiserIdsRequest) super.clone();
  }

}
