/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * Modify at your own risk.
 */

package com.google.api.services.adsdatahub.v1.model;

/**
 * Response to a DescribeValidFrequencyLimitingEventMatchersRequest request.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Ads Data Hub API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class DescribeValidFrequencyLimitingEventMatchersResponse extends com.google.api.client.json.GenericJson {

  /**
   * List of units, each containing an event matcher along with its metadata
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<EventMatcherInfo> eventMatcherInfos;

  /**
   * A token that can be used to request the next results page. This field is empty if there are no
   * additional results.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String nextPageToken;

  /**
   * List of units, each containing an event matcher along with its metadata
   * @return value or {@code null} for none
   */
  public java.util.List<EventMatcherInfo> getEventMatcherInfos() {
    return eventMatcherInfos;
  }

  /**
   * List of units, each containing an event matcher along with its metadata
   * @param eventMatcherInfos eventMatcherInfos or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public DescribeValidFrequencyLimitingEventMatchersResponse setEventMatcherInfos(java.util.List<EventMatcherInfo> eventMatcherInfos) {
    this.eventMatcherInfos = eventMatcherInfos;
    return this;
  }

  /**
   * A token that can be used to request the next results page. This field is empty if there are no
   * additional results.
   * @return value or {@code null} for none
   */
  public java.lang.String getNextPageToken() {
    return nextPageToken;
  }

  /**
   * A token that can be used to request the next results page. This field is empty if there are no
   * additional results.
   * @param nextPageToken nextPageToken or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public DescribeValidFrequencyLimitingEventMatchersResponse setNextPageToken(java.lang.String nextPageToken) {
    this.nextPageToken = nextPageToken;
    return this;
  }

  @Override
  public DescribeValidFrequencyLimitingEventMatchersResponse set(String fieldName, Object value) {
    return (DescribeValidFrequencyLimitingEventMatchersResponse) super.set(fieldName, value);
  }

  @Override
  public DescribeValidFrequencyLimitingEventMatchersResponse clone() {
    return (DescribeValidFrequencyLimitingEventMatchersResponse) super.clone();
  }

}
