/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * Modify at your own risk.
 */

package com.google.api.services.adsdatahub.v1.model;

/**
 * Metadata of an exported query output table.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Ads Data Hub API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class DestinationTableInfo extends com.google.api.client.json.GenericJson {

  /**
   * Number of rows in the result.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @com.google.api.client.json.JsonString
  private java.lang.Long rowCount;

  /**
   * Table path in the customer BigQuery project.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String tablePath;

  /**
   * Number of rows in the result.
   * @return value or {@code null} for none
   */
  public java.lang.Long getRowCount() {
    return rowCount;
  }

  /**
   * Number of rows in the result.
   * @param rowCount rowCount or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public DestinationTableInfo setRowCount(java.lang.Long rowCount) {
    this.rowCount = rowCount;
    return this;
  }

  /**
   * Table path in the customer BigQuery project.
   * @return value or {@code null} for none
   */
  public java.lang.String getTablePath() {
    return tablePath;
  }

  /**
   * Table path in the customer BigQuery project.
   * @param tablePath tablePath or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public DestinationTableInfo setTablePath(java.lang.String tablePath) {
    this.tablePath = tablePath;
    return this;
  }

  @Override
  public DestinationTableInfo set(String fieldName, Object value) {
    return (DestinationTableInfo) super.set(fieldName, value);
  }

  @Override
  public DestinationTableInfo clone() {
    return (DestinationTableInfo) super.clone();
  }

}
