/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * Modify at your own risk.
 */

package com.google.api.services.adsdatahub.v1.model;

/**
 * Represents an advertising entity that can be linked to an Ads Data Hub customer.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Ads Data Hub API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Entity extends com.google.api.client.json.GenericJson {

  /**
   * Entity display name.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String displayName;

  /**
   * Entity ID. The value listed here is dependent on the entity type.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @com.google.api.client.json.JsonString
  private java.lang.Long entityId;

  /**
   * Type of linked entity.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String type;

  /**
   * Entity display name.
   * @return value or {@code null} for none
   */
  public java.lang.String getDisplayName() {
    return displayName;
  }

  /**
   * Entity display name.
   * @param displayName displayName or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public Entity setDisplayName(java.lang.String displayName) {
    this.displayName = displayName;
    return this;
  }

  /**
   * Entity ID. The value listed here is dependent on the entity type.
   * @return value or {@code null} for none
   */
  public java.lang.Long getEntityId() {
    return entityId;
  }

  /**
   * Entity ID. The value listed here is dependent on the entity type.
   * @param entityId entityId or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public Entity setEntityId(java.lang.Long entityId) {
    this.entityId = entityId;
    return this;
  }

  /**
   * Type of linked entity.
   * @return value or {@code null} for none
   */
  public java.lang.String getType() {
    return type;
  }

  /**
   * Type of linked entity.
   * @param type type or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public Entity setType(java.lang.String type) {
    this.type = type;
    return this;
  }

  @Override
  public Entity set(String fieldName, Object value) {
    return (Entity) super.set(fieldName, value);
  }

  @Override
  public Entity clone() {
    return (Entity) super.clone();
  }

}
