/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * Modify at your own risk.
 */

package com.google.api.services.adsdatahub.v1.model;

/**
 * Generic event that contributes to the frequency.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Ads Data Hub API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class EventMatcher extends com.google.api.client.json.GenericJson {

  /**
   * The type of the constraint that will be included in the frequency count.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String matchType;

  /**
   * Value of the constraint. For example, for specifying a Google Ads campaign ID = 1234,
   * match_type would be GOOGLE_ADS_CAMPAIGN_ID and value would be '1234'. Events that have this
   * value for the respective MatchType will be included in the frequency count.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String value;

  /**
   * The type of the constraint that will be included in the frequency count.
   * @return value or {@code null} for none
   */
  public java.lang.String getMatchType() {
    return matchType;
  }

  /**
   * The type of the constraint that will be included in the frequency count.
   * @param matchType matchType or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public EventMatcher setMatchType(java.lang.String matchType) {
    this.matchType = matchType;
    return this;
  }

  /**
   * Value of the constraint. For example, for specifying a Google Ads campaign ID = 1234,
   * match_type would be GOOGLE_ADS_CAMPAIGN_ID and value would be '1234'. Events that have this
   * value for the respective MatchType will be included in the frequency count.
   * @return value or {@code null} for none
   */
  public java.lang.String getValue() {
    return value;
  }

  /**
   * Value of the constraint. For example, for specifying a Google Ads campaign ID = 1234,
   * match_type would be GOOGLE_ADS_CAMPAIGN_ID and value would be '1234'. Events that have this
   * value for the respective MatchType will be included in the frequency count.
   * @param value value or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public EventMatcher setValue(java.lang.String value) {
    this.value = value;
    return this;
  }

  @Override
  public EventMatcher set(String fieldName, Object value) {
    return (EventMatcher) super.set(fieldName, value);
  }

  @Override
  public EventMatcher clone() {
    return (EventMatcher) super.clone();
  }

}
