/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * Modify at your own risk.
 */

package com.google.api.services.adsdatahub.v1.model;

/**
 * Event matcher along with its metadata.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Ads Data Hub API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class EventMatcherInfo extends com.google.api.client.json.GenericJson {

  /**
   * Event matcher containing the constraint type and valid constraint ID.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private EventMatcher eventMatcher;

  /**
   * Metadata for the event matcher.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private EventMatcherMetadata eventMatcherMetadata;

  /**
   * Event matcher containing the constraint type and valid constraint ID.
   * @return value or {@code null} for none
   */
  public EventMatcher getEventMatcher() {
    return eventMatcher;
  }

  /**
   * Event matcher containing the constraint type and valid constraint ID.
   * @param eventMatcher eventMatcher or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public EventMatcherInfo setEventMatcher(EventMatcher eventMatcher) {
    this.eventMatcher = eventMatcher;
    return this;
  }

  /**
   * Metadata for the event matcher.
   * @return value or {@code null} for none
   */
  public EventMatcherMetadata getEventMatcherMetadata() {
    return eventMatcherMetadata;
  }

  /**
   * Metadata for the event matcher.
   * @param eventMatcherMetadata eventMatcherMetadata or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public EventMatcherInfo setEventMatcherMetadata(EventMatcherMetadata eventMatcherMetadata) {
    this.eventMatcherMetadata = eventMatcherMetadata;
    return this;
  }

  @Override
  public EventMatcherInfo set(String fieldName, Object value) {
    return (EventMatcherInfo) super.set(fieldName, value);
  }

  @Override
  public EventMatcherInfo clone() {
    return (EventMatcherInfo) super.clone();
  }

}
