/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * Modify at your own risk.
 */

package com.google.api.services.adsdatahub.v1.model;

/**
 * Metadata for the event matcher.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Ads Data Hub API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class EventMatcherMetadata extends com.google.api.client.json.GenericJson {

  /**
   * Name in the underlying data store for the constraint. This could be a campaign name, a line
   * item name etc.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String displayName;

  /**
   * Linked entity from AdsDataLink.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Entity entity;

  /**
   * Related parent EventMatcher, if any. If event_matcher is a DV360 line item, this field will
   * refer to the EventMatcher for the corresponding DV360 insertion order that the line item is
   * part of.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private EventMatcher parentEventMatcher;

  /**
   * Name in the underlying data store for the constraint. This could be a campaign name, a line
   * item name etc.
   * @return value or {@code null} for none
   */
  public java.lang.String getDisplayName() {
    return displayName;
  }

  /**
   * Name in the underlying data store for the constraint. This could be a campaign name, a line
   * item name etc.
   * @param displayName displayName or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public EventMatcherMetadata setDisplayName(java.lang.String displayName) {
    this.displayName = displayName;
    return this;
  }

  /**
   * Linked entity from AdsDataLink.
   * @return value or {@code null} for none
   */
  public Entity getEntity() {
    return entity;
  }

  /**
   * Linked entity from AdsDataLink.
   * @param entity entity or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public EventMatcherMetadata setEntity(Entity entity) {
    this.entity = entity;
    return this;
  }

  /**
   * Related parent EventMatcher, if any. If event_matcher is a DV360 line item, this field will
   * refer to the EventMatcher for the corresponding DV360 insertion order that the line item is
   * part of.
   * @return value or {@code null} for none
   */
  public EventMatcher getParentEventMatcher() {
    return parentEventMatcher;
  }

  /**
   * Related parent EventMatcher, if any. If event_matcher is a DV360 line item, this field will
   * refer to the EventMatcher for the corresponding DV360 insertion order that the line item is
   * part of.
   * @param parentEventMatcher parentEventMatcher or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public EventMatcherMetadata setParentEventMatcher(EventMatcher parentEventMatcher) {
    this.parentEventMatcher = parentEventMatcher;
    return this;
  }

  @Override
  public EventMatcherMetadata set(String fieldName, Object value) {
    return (EventMatcherMetadata) super.set(fieldName, value);
  }

  @Override
  public EventMatcherMetadata clone() {
    return (EventMatcherMetadata) super.clone();
  }

}
