/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * Modify at your own risk.
 */

package com.google.api.services.adsdatahub.v1.model;

/**
 * Metadata for brand safety entity export request.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Ads Data Hub API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class ExportBrandSafetyEntitiesMetadata extends com.google.api.client.json.GenericJson {

  /**
   * Export end time.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String endTime;

  /**
   * Request for exporting brand safety entities.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private ExportBrandSafetyEntitiesRequest request;

  /**
   * Export start time.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String startTime;

  /**
   * Export end time.
   * @return value or {@code null} for none
   */
  public String getEndTime() {
    return endTime;
  }

  /**
   * Export end time.
   * @param endTime endTime or {@code null} for none
   */
  public ExportBrandSafetyEntitiesMetadata setEndTime(String endTime) {
    this.endTime = endTime;
    return this;
  }

  /**
   * Request for exporting brand safety entities.
   * @return value or {@code null} for none
   */
  public ExportBrandSafetyEntitiesRequest getRequest() {
    return request;
  }

  /**
   * Request for exporting brand safety entities.
   * @param request request or {@code null} for none
   */
  public ExportBrandSafetyEntitiesMetadata setRequest(ExportBrandSafetyEntitiesRequest request) {
    this.request = request;
    return this;
  }

  /**
   * Export start time.
   * @return value or {@code null} for none
   */
  public String getStartTime() {
    return startTime;
  }

  /**
   * Export start time.
   * @param startTime startTime or {@code null} for none
   */
  public ExportBrandSafetyEntitiesMetadata setStartTime(String startTime) {
    this.startTime = startTime;
    return this;
  }

  @Override
  public ExportBrandSafetyEntitiesMetadata set(String fieldName, Object value) {
    return (ExportBrandSafetyEntitiesMetadata) super.set(fieldName, value);
  }

  @Override
  public ExportBrandSafetyEntitiesMetadata clone() {
    return (ExportBrandSafetyEntitiesMetadata) super.clone();
  }

}
