/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * Modify at your own risk.
 */

package com.google.api.services.adsdatahub.v1.model;

/**
 * Request to start execution of a Brand Safety entity export.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Ads Data Hub API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class ExportBrandSafetyEntitiesRequest extends com.google.api.client.json.GenericJson {

  /**
   * Linked Ads Data Hub customer ID that owns the ads data.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @com.google.api.client.json.JsonString
  private java.lang.Long adsDataCustomerId;

  /**
   * The date for brand safety entity exports. Any impressions that occurred on this date will be
   * provided.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Date date;

  /**
   * Destination BigQuery table for the results with format 'project.dataset.table_name'. If project
   * is not specified, uses default project for the provided customer. If neither project nor
   * dataset is specified, uses the default project and dataset.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String destTable;

  /**
   * Ads Data Hub customer making the request. This is in the form of 'customers/[customer_id]'.
   * e.g. 'customers/123'.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String name;

  /**
   * Advertising platform associate with the request.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String platform;

  /**
   * Linked Ads Data Hub customer ID that owns the ads data.
   * @return value or {@code null} for none
   */
  public java.lang.Long getAdsDataCustomerId() {
    return adsDataCustomerId;
  }

  /**
   * Linked Ads Data Hub customer ID that owns the ads data.
   * @param adsDataCustomerId adsDataCustomerId or {@code null} for none
   */
  public ExportBrandSafetyEntitiesRequest setAdsDataCustomerId(java.lang.Long adsDataCustomerId) {
    this.adsDataCustomerId = adsDataCustomerId;
    return this;
  }

  /**
   * The date for brand safety entity exports. Any impressions that occurred on this date will be
   * provided.
   * @return value or {@code null} for none
   */
  public Date getDate() {
    return date;
  }

  /**
   * The date for brand safety entity exports. Any impressions that occurred on this date will be
   * provided.
   * @param date date or {@code null} for none
   */
  public ExportBrandSafetyEntitiesRequest setDate(Date date) {
    this.date = date;
    return this;
  }

  /**
   * Destination BigQuery table for the results with format 'project.dataset.table_name'. If project
   * is not specified, uses default project for the provided customer. If neither project nor
   * dataset is specified, uses the default project and dataset.
   * @return value or {@code null} for none
   */
  public java.lang.String getDestTable() {
    return destTable;
  }

  /**
   * Destination BigQuery table for the results with format 'project.dataset.table_name'. If project
   * is not specified, uses default project for the provided customer. If neither project nor
   * dataset is specified, uses the default project and dataset.
   * @param destTable destTable or {@code null} for none
   */
  public ExportBrandSafetyEntitiesRequest setDestTable(java.lang.String destTable) {
    this.destTable = destTable;
    return this;
  }

  /**
   * Ads Data Hub customer making the request. This is in the form of 'customers/[customer_id]'.
   * e.g. 'customers/123'.
   * @return value or {@code null} for none
   */
  public java.lang.String getName() {
    return name;
  }

  /**
   * Ads Data Hub customer making the request. This is in the form of 'customers/[customer_id]'.
   * e.g. 'customers/123'.
   * @param name name or {@code null} for none
   */
  public ExportBrandSafetyEntitiesRequest setName(java.lang.String name) {
    this.name = name;
    return this;
  }

  /**
   * Advertising platform associate with the request.
   * @return value or {@code null} for none
   */
  public java.lang.String getPlatform() {
    return platform;
  }

  /**
   * Advertising platform associate with the request.
   * @param platform platform or {@code null} for none
   */
  public ExportBrandSafetyEntitiesRequest setPlatform(java.lang.String platform) {
    this.platform = platform;
    return this;
  }

  @Override
  public ExportBrandSafetyEntitiesRequest set(String fieldName, Object value) {
    return (ExportBrandSafetyEntitiesRequest) super.set(fieldName, value);
  }

  @Override
  public ExportBrandSafetyEntitiesRequest clone() {
    return (ExportBrandSafetyEntitiesRequest) super.clone();
  }

}
