/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * Modify at your own risk.
 */

package com.google.api.services.adsdatahub.v1.model;

/**
 * Request to export job history.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Ads Data Hub API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class ExportJobHistoryRequest extends com.google.api.client.json.GenericJson {

  /**
   * Required. Customer dataset that the query audit log will be written to.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String dataset;

  /**
   * Required. End date for date range for job history export, exclusive. Currently, only a single
   * day's worth of query job history can be exported.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Date endDate;

  /**
   * Required. Customer project ID that the query audit log will be written to.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String projectId;

  /**
   * Required. Job history will be exported for jobs started on or after start_date but before
   * end_date. start_date cannot be more than 30 days from the current date.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Date startDate;

  /**
   * Optional. The time zone for the start date. If not specified, defaults to 'UTC'.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String timeZone;

  /**
   * Required. Customer dataset that the query audit log will be written to.
   * @return value or {@code null} for none
   */
  public java.lang.String getDataset() {
    return dataset;
  }

  /**
   * Required. Customer dataset that the query audit log will be written to.
   * @param dataset dataset or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public ExportJobHistoryRequest setDataset(java.lang.String dataset) {
    this.dataset = dataset;
    return this;
  }

  /**
   * Required. End date for date range for job history export, exclusive. Currently, only a single
   * day's worth of query job history can be exported.
   * @return value or {@code null} for none
   */
  public Date getEndDate() {
    return endDate;
  }

  /**
   * Required. End date for date range for job history export, exclusive. Currently, only a single
   * day's worth of query job history can be exported.
   * @param endDate endDate or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public ExportJobHistoryRequest setEndDate(Date endDate) {
    this.endDate = endDate;
    return this;
  }

  /**
   * Required. Customer project ID that the query audit log will be written to.
   * @return value or {@code null} for none
   */
  public java.lang.String getProjectId() {
    return projectId;
  }

  /**
   * Required. Customer project ID that the query audit log will be written to.
   * @param projectId projectId or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public ExportJobHistoryRequest setProjectId(java.lang.String projectId) {
    this.projectId = projectId;
    return this;
  }

  /**
   * Required. Job history will be exported for jobs started on or after start_date but before
   * end_date. start_date cannot be more than 30 days from the current date.
   * @return value or {@code null} for none
   */
  public Date getStartDate() {
    return startDate;
  }

  /**
   * Required. Job history will be exported for jobs started on or after start_date but before
   * end_date. start_date cannot be more than 30 days from the current date.
   * @param startDate startDate or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public ExportJobHistoryRequest setStartDate(Date startDate) {
    this.startDate = startDate;
    return this;
  }

  /**
   * Optional. The time zone for the start date. If not specified, defaults to 'UTC'.
   * @return value or {@code null} for none
   */
  public java.lang.String getTimeZone() {
    return timeZone;
  }

  /**
   * Optional. The time zone for the start date. If not specified, defaults to 'UTC'.
   * @param timeZone timeZone or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public ExportJobHistoryRequest setTimeZone(java.lang.String timeZone) {
    this.timeZone = timeZone;
    return this;
  }

  @Override
  public ExportJobHistoryRequest set(String fieldName, Object value) {
    return (ExportJobHistoryRequest) super.set(fieldName, value);
  }

  @Override
  public ExportJobHistoryRequest clone() {
    return (ExportJobHistoryRequest) super.clone();
  }

}
