/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * Modify at your own risk.
 */

package com.google.api.services.adsdatahub.v1.model;

/**
 * Defines a BigQuery field type.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Ads Data Hub API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class FieldType extends com.google.api.client.json.GenericJson {

  /**
   * Type of the array's elements, if this is an 'ARRAY' type.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private FieldType arrayType;

  /**
   * Struct field type, if this is a 'STRUCT' type.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private StructType structType;

  /**
   * BigQuery simple type, e.g. 'STRING' or 'INT64'. See
   * https://cloud.google.com/bigquery/docs/reference/standard-sql/data-types.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String type;

  /**
   * Type of the array's elements, if this is an 'ARRAY' type.
   * @return value or {@code null} for none
   */
  public FieldType getArrayType() {
    return arrayType;
  }

  /**
   * Type of the array's elements, if this is an 'ARRAY' type.
   * @param arrayType arrayType or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public FieldType setArrayType(FieldType arrayType) {
    this.arrayType = arrayType;
    return this;
  }

  /**
   * Struct field type, if this is a 'STRUCT' type.
   * @return value or {@code null} for none
   */
  public StructType getStructType() {
    return structType;
  }

  /**
   * Struct field type, if this is a 'STRUCT' type.
   * @param structType structType or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public FieldType setStructType(StructType structType) {
    this.structType = structType;
    return this;
  }

  /**
   * BigQuery simple type, e.g. 'STRING' or 'INT64'. See
   * https://cloud.google.com/bigquery/docs/reference/standard-sql/data-types.
   * @return value or {@code null} for none
   */
  public java.lang.String getType() {
    return type;
  }

  /**
   * BigQuery simple type, e.g. 'STRING' or 'INT64'. See
   * https://cloud.google.com/bigquery/docs/reference/standard-sql/data-types.
   * @param type type or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public FieldType setType(java.lang.String type) {
    this.type = type;
    return this;
  }

  @Override
  public FieldType set(String fieldName, Object value) {
    return (FieldType) super.set(fieldName, value);
  }

  @Override
  public FieldType clone() {
    return (FieldType) super.clone();
  }

}
