/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * Modify at your own risk.
 */

package com.google.api.services.adsdatahub.v1.model;

/**
 * Merge instructions for an analysis query result schema.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Ads Data Hub API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class FilteredRowSummary extends com.google.api.client.json.GenericJson {

  /**
   * Instructions for merging each column, keyed by name. Any missing columns will be treated as
   * SUMMARY_TYPE_UNSPECIFIED.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.Map<String, ColumnSummaryRule> columns;

  /**
   * Instructions for merging each column, keyed by name. Any missing columns will be treated as
   * SUMMARY_TYPE_UNSPECIFIED.
   * @return value or {@code null} for none
   */
  public java.util.Map<String, ColumnSummaryRule> getColumns() {
    return columns;
  }

  /**
   * Instructions for merging each column, keyed by name. Any missing columns will be treated as
   * SUMMARY_TYPE_UNSPECIFIED.
   * @param columns columns or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public FilteredRowSummary setColumns(java.util.Map<String, ColumnSummaryRule> columns) {
    this.columns = columns;
    return this;
  }

  @Override
  public FilteredRowSummary set(String fieldName, Object value) {
    return (FilteredRowSummary) super.set(fieldName, value);
  }

  @Override
  public FilteredRowSummary clone() {
    return (FilteredRowSummary) super.clone();
  }

}
