/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * Modify at your own risk.
 */

package com.google.api.services.adsdatahub.v1.model;

/**
 * Metadata for frequency-based User List.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Ads Data Hub API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class FrequencyBasedListInfo extends com.google.api.client.json.GenericJson {

  /**
   * Ids for CM campaigns that contribute to the frequency.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @com.google.api.client.json.JsonString
  private java.util.List<java.lang.Long> cmCampaignIds;

  /**
   * Ids for DV360 line items that contribute to the frequency.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @com.google.api.client.json.JsonString
  private java.util.List<java.lang.Long> dv360LineitemIds;

  /**
   * Which events contribute to the frequency. When creating frequency-based user lists,
   * eventMatchers is preferred for specifying events contributing to the frequency.
   * dv360LineitemIds, cmCampaignIds, and googleAdsCampaignIds are used if eventMatchers is empty.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<EventMatcher> eventMatchers;

  /**
   * Describes when a user gets added to the list.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private FrequencyConstraint frequencyConstraint;

  /**
   * Ids for Google Ads campaigns that contribute to the frequency.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @com.google.api.client.json.JsonString
  private java.util.List<java.lang.Long> googleAdsCampaignIds;

  /**
   * Required. Time window size used when calculating the frequency of each event. This is measure
   * in days
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Integer slidingWindowDays;

  /**
   * Ids for CM campaigns that contribute to the frequency.
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.Long> getCmCampaignIds() {
    return cmCampaignIds;
  }

  /**
   * Ids for CM campaigns that contribute to the frequency.
   * @param cmCampaignIds cmCampaignIds or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public FrequencyBasedListInfo setCmCampaignIds(java.util.List<java.lang.Long> cmCampaignIds) {
    this.cmCampaignIds = cmCampaignIds;
    return this;
  }

  /**
   * Ids for DV360 line items that contribute to the frequency.
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.Long> getDv360LineitemIds() {
    return dv360LineitemIds;
  }

  /**
   * Ids for DV360 line items that contribute to the frequency.
   * @param dv360LineitemIds dv360LineitemIds or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public FrequencyBasedListInfo setDv360LineitemIds(java.util.List<java.lang.Long> dv360LineitemIds) {
    this.dv360LineitemIds = dv360LineitemIds;
    return this;
  }

  /**
   * Which events contribute to the frequency. When creating frequency-based user lists,
   * eventMatchers is preferred for specifying events contributing to the frequency.
   * dv360LineitemIds, cmCampaignIds, and googleAdsCampaignIds are used if eventMatchers is empty.
   * @return value or {@code null} for none
   */
  public java.util.List<EventMatcher> getEventMatchers() {
    return eventMatchers;
  }

  /**
   * Which events contribute to the frequency. When creating frequency-based user lists,
   * eventMatchers is preferred for specifying events contributing to the frequency.
   * dv360LineitemIds, cmCampaignIds, and googleAdsCampaignIds are used if eventMatchers is empty.
   * @param eventMatchers eventMatchers or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public FrequencyBasedListInfo setEventMatchers(java.util.List<EventMatcher> eventMatchers) {
    this.eventMatchers = eventMatchers;
    return this;
  }

  /**
   * Describes when a user gets added to the list.
   * @return value or {@code null} for none
   */
  public FrequencyConstraint getFrequencyConstraint() {
    return frequencyConstraint;
  }

  /**
   * Describes when a user gets added to the list.
   * @param frequencyConstraint frequencyConstraint or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public FrequencyBasedListInfo setFrequencyConstraint(FrequencyConstraint frequencyConstraint) {
    this.frequencyConstraint = frequencyConstraint;
    return this;
  }

  /**
   * Ids for Google Ads campaigns that contribute to the frequency.
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.Long> getGoogleAdsCampaignIds() {
    return googleAdsCampaignIds;
  }

  /**
   * Ids for Google Ads campaigns that contribute to the frequency.
   * @param googleAdsCampaignIds googleAdsCampaignIds or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public FrequencyBasedListInfo setGoogleAdsCampaignIds(java.util.List<java.lang.Long> googleAdsCampaignIds) {
    this.googleAdsCampaignIds = googleAdsCampaignIds;
    return this;
  }

  /**
   * Required. Time window size used when calculating the frequency of each event. This is measure
   * in days
   * @return value or {@code null} for none
   */
  public java.lang.Integer getSlidingWindowDays() {
    return slidingWindowDays;
  }

  /**
   * Required. Time window size used when calculating the frequency of each event. This is measure
   * in days
   * @param slidingWindowDays slidingWindowDays or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public FrequencyBasedListInfo setSlidingWindowDays(java.lang.Integer slidingWindowDays) {
    this.slidingWindowDays = slidingWindowDays;
    return this;
  }

  @Override
  public FrequencyBasedListInfo set(String fieldName, Object value) {
    return (FrequencyBasedListInfo) super.set(fieldName, value);
  }

  @Override
  public FrequencyBasedListInfo clone() {
    return (FrequencyBasedListInfo) super.clone();
  }

}
