/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * Modify at your own risk.
 */

package com.google.api.services.adsdatahub.v1.model;

/**
 * Specify the minimum number of events for the cap.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Ads Data Hub API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class FrequencyConstraint extends com.google.api.client.json.GenericJson {

  /**
   * Immutable. The type of event that will be counted against threshold_event_count. For now we do
   * not explicitly represent the comparison constraints assuming all are GREATER_OR_EQUAL.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String eventType;

  /**
   * Required. Each user should appear in at least K events.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @com.google.api.client.json.JsonString
  private java.lang.Long thresholdEventCount;

  /**
   * Immutable. The type of event that will be counted against threshold_event_count. For now we do
   * not explicitly represent the comparison constraints assuming all are GREATER_OR_EQUAL.
   * @return value or {@code null} for none
   */
  public java.lang.String getEventType() {
    return eventType;
  }

  /**
   * Immutable. The type of event that will be counted against threshold_event_count. For now we do
   * not explicitly represent the comparison constraints assuming all are GREATER_OR_EQUAL.
   * @param eventType eventType or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public FrequencyConstraint setEventType(java.lang.String eventType) {
    this.eventType = eventType;
    return this;
  }

  /**
   * Required. Each user should appear in at least K events.
   * @return value or {@code null} for none
   */
  public java.lang.Long getThresholdEventCount() {
    return thresholdEventCount;
  }

  /**
   * Required. Each user should appear in at least K events.
   * @param thresholdEventCount thresholdEventCount or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public FrequencyConstraint setThresholdEventCount(java.lang.Long thresholdEventCount) {
    this.thresholdEventCount = thresholdEventCount;
    return this;
  }

  @Override
  public FrequencyConstraint set(String fieldName, Object value) {
    return (FrequencyConstraint) super.set(fieldName, value);
  }

  @Override
  public FrequencyConstraint clone() {
    return (FrequencyConstraint) super.clone();
  }

}
