/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * Modify at your own risk.
 */

package com.google.api.services.adsdatahub.v1.model;

/**
 * Response to a GetImportCompletionStatus request.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Ads Data Hub API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class ImportCompletionStatus extends com.google.api.client.json.GenericJson {

  /**
   * The name of the import completion status resource in the format of
   * 'customers/{id}/importStatus/{date}_{utc_offset}'
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String name;

  /**
   * Percent of Google data being imported across all ADH customers for a given date that is
   * complete.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String percentile;

  /**
   * The name of the import completion status resource in the format of
   * 'customers/{id}/importStatus/{date}_{utc_offset}'
   * @return value or {@code null} for none
   */
  public java.lang.String getName() {
    return name;
  }

  /**
   * The name of the import completion status resource in the format of
   * 'customers/{id}/importStatus/{date}_{utc_offset}'
   * @param name name or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public ImportCompletionStatus setName(java.lang.String name) {
    this.name = name;
    return this;
  }

  /**
   * Percent of Google data being imported across all ADH customers for a given date that is
   * complete.
   * @return value or {@code null} for none
   */
  public java.lang.String getPercentile() {
    return percentile;
  }

  /**
   * Percent of Google data being imported across all ADH customers for a given date that is
   * complete.
   * @param percentile percentile or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public ImportCompletionStatus setPercentile(java.lang.String percentile) {
    this.percentile = percentile;
    return this;
  }

  @Override
  public ImportCompletionStatus set(String fieldName, Object value) {
    return (ImportCompletionStatus) super.set(fieldName, value);
  }

  @Override
  public ImportCompletionStatus clone() {
    return (ImportCompletionStatus) super.clone();
  }

}
