/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * Modify at your own risk.
 */

package com.google.api.services.adsdatahub.v1.model;

/**
 * Metadata about a job history export job. This is stored in the metadata field of the
 * google.longrunning.Operation returned by a query execution request.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Ads Data Hub API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class JobHistoryExportMetadata extends com.google.api.client.json.GenericJson {

  /**
   * The Ads Data Hub customer ID that ran the query.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @com.google.api.client.json.JsonString
  private java.lang.Long customerId;

  /**
   * Destination BigQuery dataset ID.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String destDataset;

  /**
   * Destination BigQuery project ID.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String destProject;

  /**
   * Time this job history export ended.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String exportEndTime;

  /**
   * Time this job history export began.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String exportStartTime;

  /**
   * Ending time range for jobs included in this export, exclusive.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String timeRangeEndTime;

  /**
   * Starting time range for jobs included in this export, inclusive.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String timeRangeStartTime;

  /**
   * The Ads Data Hub customer ID that ran the query.
   * @return value or {@code null} for none
   */
  public java.lang.Long getCustomerId() {
    return customerId;
  }

  /**
   * The Ads Data Hub customer ID that ran the query.
   * @param customerId customerId or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public JobHistoryExportMetadata setCustomerId(java.lang.Long customerId) {
    this.customerId = customerId;
    return this;
  }

  /**
   * Destination BigQuery dataset ID.
   * @return value or {@code null} for none
   */
  public java.lang.String getDestDataset() {
    return destDataset;
  }

  /**
   * Destination BigQuery dataset ID.
   * @param destDataset destDataset or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public JobHistoryExportMetadata setDestDataset(java.lang.String destDataset) {
    this.destDataset = destDataset;
    return this;
  }

  /**
   * Destination BigQuery project ID.
   * @return value or {@code null} for none
   */
  public java.lang.String getDestProject() {
    return destProject;
  }

  /**
   * Destination BigQuery project ID.
   * @param destProject destProject or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public JobHistoryExportMetadata setDestProject(java.lang.String destProject) {
    this.destProject = destProject;
    return this;
  }

  /**
   * Time this job history export ended.
   * @return value or {@code null} for none
   */
  public String getExportEndTime() {
    return exportEndTime;
  }

  /**
   * Time this job history export ended.
   * @param exportEndTime exportEndTime or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public JobHistoryExportMetadata setExportEndTime(String exportEndTime) {
    this.exportEndTime = exportEndTime;
    return this;
  }

  /**
   * Time this job history export began.
   * @return value or {@code null} for none
   */
  public String getExportStartTime() {
    return exportStartTime;
  }

  /**
   * Time this job history export began.
   * @param exportStartTime exportStartTime or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public JobHistoryExportMetadata setExportStartTime(String exportStartTime) {
    this.exportStartTime = exportStartTime;
    return this;
  }

  /**
   * Ending time range for jobs included in this export, exclusive.
   * @return value or {@code null} for none
   */
  public String getTimeRangeEndTime() {
    return timeRangeEndTime;
  }

  /**
   * Ending time range for jobs included in this export, exclusive.
   * @param timeRangeEndTime timeRangeEndTime or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public JobHistoryExportMetadata setTimeRangeEndTime(String timeRangeEndTime) {
    this.timeRangeEndTime = timeRangeEndTime;
    return this;
  }

  /**
   * Starting time range for jobs included in this export, inclusive.
   * @return value or {@code null} for none
   */
  public String getTimeRangeStartTime() {
    return timeRangeStartTime;
  }

  /**
   * Starting time range for jobs included in this export, inclusive.
   * @param timeRangeStartTime timeRangeStartTime or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public JobHistoryExportMetadata setTimeRangeStartTime(String timeRangeStartTime) {
    this.timeRangeStartTime = timeRangeStartTime;
    return this;
  }

  @Override
  public JobHistoryExportMetadata set(String fieldName, Object value) {
    return (JobHistoryExportMetadata) super.set(fieldName, value);
  }

  @Override
  public JobHistoryExportMetadata clone() {
    return (JobHistoryExportMetadata) super.clone();
  }

}
