/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * Modify at your own risk.
 */

package com.google.api.services.adsdatahub.v1.model;

/**
 * Response returned for successful job history exports. This is stored in the response field of the
 * google.longrunning.Operation returned by a job history export request.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Ads Data Hub API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class JobHistoryExportResponse extends com.google.api.client.json.GenericJson {

  /**
   * Destination BigQuery dataset for the job history export.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String destDataset;

  /**
   * Destination BigQuery project for the job history export.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String destProject;

  /**
   * Destination BigQuery table for the job history export.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String destTable;

  /**
   * Job count in the final output table.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @com.google.api.client.json.JsonString
  private java.lang.Long jobCount;

  /**
   * Destination BigQuery dataset for the job history export.
   * @return value or {@code null} for none
   */
  public java.lang.String getDestDataset() {
    return destDataset;
  }

  /**
   * Destination BigQuery dataset for the job history export.
   * @param destDataset destDataset or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public JobHistoryExportResponse setDestDataset(java.lang.String destDataset) {
    this.destDataset = destDataset;
    return this;
  }

  /**
   * Destination BigQuery project for the job history export.
   * @return value or {@code null} for none
   */
  public java.lang.String getDestProject() {
    return destProject;
  }

  /**
   * Destination BigQuery project for the job history export.
   * @param destProject destProject or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public JobHistoryExportResponse setDestProject(java.lang.String destProject) {
    this.destProject = destProject;
    return this;
  }

  /**
   * Destination BigQuery table for the job history export.
   * @return value or {@code null} for none
   */
  public java.lang.String getDestTable() {
    return destTable;
  }

  /**
   * Destination BigQuery table for the job history export.
   * @param destTable destTable or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public JobHistoryExportResponse setDestTable(java.lang.String destTable) {
    this.destTable = destTable;
    return this;
  }

  /**
   * Job count in the final output table.
   * @return value or {@code null} for none
   */
  public java.lang.Long getJobCount() {
    return jobCount;
  }

  /**
   * Job count in the final output table.
   * @param jobCount jobCount or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public JobHistoryExportResponse setJobCount(java.lang.Long jobCount) {
    this.jobCount = jobCount;
    return this;
  }

  @Override
  public JobHistoryExportResponse set(String fieldName, Object value) {
    return (JobHistoryExportResponse) super.set(fieldName, value);
  }

  @Override
  public JobHistoryExportResponse clone() {
    return (JobHistoryExportResponse) super.clone();
  }

}
