/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * Modify at your own risk.
 */

package com.google.api.services.adsdatahub.v1.model;

/**
 * Response to a ListOutages request, contains the outages.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Ads Data Hub API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class ListOutagesResponse extends com.google.api.client.json.GenericJson {

  /**
   * A token, which can be sent as `page_token` to retrieve the next page. If this field is omitted,
   * there are no subsequent pages.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String nextPageToken;

  /**
   * The outages within the look back window
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Outage> outages;

  /**
   * A token, which can be sent as `page_token` to retrieve the next page. If this field is omitted,
   * there are no subsequent pages.
   * @return value or {@code null} for none
   */
  public java.lang.String getNextPageToken() {
    return nextPageToken;
  }

  /**
   * A token, which can be sent as `page_token` to retrieve the next page. If this field is omitted,
   * there are no subsequent pages.
   * @param nextPageToken nextPageToken or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public ListOutagesResponse setNextPageToken(java.lang.String nextPageToken) {
    this.nextPageToken = nextPageToken;
    return this;
  }

  /**
   * The outages within the look back window
   * @return value or {@code null} for none
   */
  public java.util.List<Outage> getOutages() {
    return outages;
  }

  /**
   * The outages within the look back window
   * @param outages outages or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public ListOutagesResponse setOutages(java.util.List<Outage> outages) {
    this.outages = outages;
    return this;
  }

  @Override
  public ListOutagesResponse set(String fieldName, Object value) {
    return (ListOutagesResponse) super.set(fieldName, value);
  }

  @Override
  public ListOutagesResponse clone() {
    return (ListOutagesResponse) super.clone();
  }

}
