/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * Modify at your own risk.
 */

package com.google.api.services.adsdatahub.v1.model;

/**
 * Defines an outage and its information.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Ads Data Hub API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Outage extends com.google.api.client.json.GenericJson {

  /**
   * Message describing this outage.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String details;

  /**
   * The absolute point in time when the outage ended or will end. If empty or in the future, then
   * it means the outage is still on going.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String endTime;

  /**
   * Name that uniquely identifies an outage. It has the form outages/[outage_id], e.g.
   * 'outages/1234'.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String name;

  /**
   * The absolute point in time when the outage started.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String startTime;

  /**
   * The type of this outage.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String type;

  /**
   * Message describing this outage.
   * @return value or {@code null} for none
   */
  public java.lang.String getDetails() {
    return details;
  }

  /**
   * Message describing this outage.
   * @param details details or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public Outage setDetails(java.lang.String details) {
    this.details = details;
    return this;
  }

  /**
   * The absolute point in time when the outage ended or will end. If empty or in the future, then
   * it means the outage is still on going.
   * @return value or {@code null} for none
   */
  public String getEndTime() {
    return endTime;
  }

  /**
   * The absolute point in time when the outage ended or will end. If empty or in the future, then
   * it means the outage is still on going.
   * @param endTime endTime or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public Outage setEndTime(String endTime) {
    this.endTime = endTime;
    return this;
  }

  /**
   * Name that uniquely identifies an outage. It has the form outages/[outage_id], e.g.
   * 'outages/1234'.
   * @return value or {@code null} for none
   */
  public java.lang.String getName() {
    return name;
  }

  /**
   * Name that uniquely identifies an outage. It has the form outages/[outage_id], e.g.
   * 'outages/1234'.
   * @param name name or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public Outage setName(java.lang.String name) {
    this.name = name;
    return this;
  }

  /**
   * The absolute point in time when the outage started.
   * @return value or {@code null} for none
   */
  public String getStartTime() {
    return startTime;
  }

  /**
   * The absolute point in time when the outage started.
   * @param startTime startTime or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public Outage setStartTime(String startTime) {
    this.startTime = startTime;
    return this;
  }

  /**
   * The type of this outage.
   * @return value or {@code null} for none
   */
  public java.lang.String getType() {
    return type;
  }

  /**
   * The type of this outage.
   * @param type type or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public Outage setType(java.lang.String type) {
    this.type = type;
    return this;
  }

  @Override
  public Outage set(String fieldName, Object value) {
    return (Outage) super.set(fieldName, value);
  }

  @Override
  public Outage clone() {
    return (Outage) super.clone();
  }

}
