/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * Modify at your own risk.
 */

package com.google.api.services.adsdatahub.v1.model;

/**
 * Output artifacts created during query execution, e.g. Temp tables are created using CREATE TABLE
 * temp_table AS (...) in an Ads Data Hub query.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Ads Data Hub API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class OutputArtifacts extends com.google.api.client.json.GenericJson {

  /**
   * Defines list of temp tables created by an Ads Data Hub query.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<TempTable> tempTables;

  static {
    // hack to force ProGuard to consider TempTable used, since otherwise it would be stripped out
    // see https://github.com/google/google-api-java-client/issues/543
    com.google.api.client.util.Data.nullOf(TempTable.class);
  }

  /**
   * Defines list of temp tables created by an Ads Data Hub query.
   * @return value or {@code null} for none
   */
  public java.util.List<TempTable> getTempTables() {
    return tempTables;
  }

  /**
   * Defines list of temp tables created by an Ads Data Hub query.
   * @param tempTables tempTables or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public OutputArtifacts setTempTables(java.util.List<TempTable> tempTables) {
    this.tempTables = tempTables;
    return this;
  }

  @Override
  public OutputArtifacts set(String fieldName, Object value) {
    return (OutputArtifacts) super.set(fieldName, value);
  }

  @Override
  public OutputArtifacts clone() {
    return (OutputArtifacts) super.clone();
  }

}
