/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * Modify at your own risk.
 */

package com.google.api.services.adsdatahub.v1.model;

/**
 * Information about a specific query parameter.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Ads Data Hub API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class ParameterType extends com.google.api.client.json.GenericJson {

  /**
   * Optional. Value that should be used if no parameter value is provided.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private ParameterValue defaultValue;

  /**
   * Optional. Parameter description.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String description;

  /**
   * Parameter field type.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private FieldType type;

  /**
   * Optional. Value that should be used if no parameter value is provided.
   * @return value or {@code null} for none
   */
  public ParameterValue getDefaultValue() {
    return defaultValue;
  }

  /**
   * Optional. Value that should be used if no parameter value is provided.
   * @param defaultValue defaultValue or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public ParameterType setDefaultValue(ParameterValue defaultValue) {
    this.defaultValue = defaultValue;
    return this;
  }

  /**
   * Optional. Parameter description.
   * @return value or {@code null} for none
   */
  public java.lang.String getDescription() {
    return description;
  }

  /**
   * Optional. Parameter description.
   * @param description description or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public ParameterType setDescription(java.lang.String description) {
    this.description = description;
    return this;
  }

  /**
   * Parameter field type.
   * @return value or {@code null} for none
   */
  public FieldType getType() {
    return type;
  }

  /**
   * Parameter field type.
   * @param type type or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public ParameterType setType(FieldType type) {
    this.type = type;
    return this;
  }

  @Override
  public ParameterType set(String fieldName, Object value) {
    return (ParameterType) super.set(fieldName, value);
  }

  @Override
  public ParameterType clone() {
    return (ParameterType) super.clone();
  }

}
