/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * Modify at your own risk.
 */

package com.google.api.services.adsdatahub.v1.model;

/**
 * Represents a BigQuery parameter value.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Ads Data Hub API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class ParameterValue extends com.google.api.client.json.GenericJson {

  /**
   * Value for an array parameter.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private ArrayValue arrayValue;

  /**
   * Value for a struct parameter.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private StructValue structValue;

  /**
   * Value for a non-array, non-struct parameter.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String value;

  /**
   * Value for an array parameter.
   * @return value or {@code null} for none
   */
  public ArrayValue getArrayValue() {
    return arrayValue;
  }

  /**
   * Value for an array parameter.
   * @param arrayValue arrayValue or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public ParameterValue setArrayValue(ArrayValue arrayValue) {
    this.arrayValue = arrayValue;
    return this;
  }

  /**
   * Value for a struct parameter.
   * @return value or {@code null} for none
   */
  public StructValue getStructValue() {
    return structValue;
  }

  /**
   * Value for a struct parameter.
   * @param structValue structValue or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public ParameterValue setStructValue(StructValue structValue) {
    this.structValue = structValue;
    return this;
  }

  /**
   * Value for a non-array, non-struct parameter.
   * @return value or {@code null} for none
   */
  public java.lang.String getValue() {
    return value;
  }

  /**
   * Value for a non-array, non-struct parameter.
   * @param value value or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public ParameterValue setValue(java.lang.String value) {
    this.value = value;
    return this;
  }

  @Override
  public ParameterValue set(String fieldName, Object value) {
    return (ParameterValue) super.set(fieldName, value);
  }

  @Override
  public ParameterValue clone() {
    return (ParameterValue) super.clone();
  }

}
