/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * Modify at your own risk.
 */

package com.google.api.services.adsdatahub.v1.model;

/**
 * Privacy related information or warning message.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Ads Data Hub API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class PrivacyMessage extends com.google.api.client.json.GenericJson {

  /**
   * Text of the message.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String details;

  /**
   * Type of the message.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String type;

  /**
   * Text of the message.
   * @return value or {@code null} for none
   */
  public java.lang.String getDetails() {
    return details;
  }

  /**
   * Text of the message.
   * @param details details or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public PrivacyMessage setDetails(java.lang.String details) {
    this.details = details;
    return this;
  }

  /**
   * Type of the message.
   * @return value or {@code null} for none
   */
  public java.lang.String getType() {
    return type;
  }

  /**
   * Type of the message.
   * @param type type or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public PrivacyMessage setType(java.lang.String type) {
    this.type = type;
    return this;
  }

  @Override
  public PrivacyMessage set(String fieldName, Object value) {
    return (PrivacyMessage) super.set(fieldName, value);
  }

  @Override
  public PrivacyMessage clone() {
    return (PrivacyMessage) super.clone();
  }

}
