/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * Modify at your own risk.
 */

package com.google.api.services.adsdatahub.v1.model;

/**
 * Performance info for the query execution.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Ads Data Hub API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class QueryPerformanceInfo extends com.google.api.client.json.GenericJson {

  /**
   * True if the processed data is less than 1 MiB.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean lessThanOneMb;

  /**
   * MiB data this query reads. Set if the data size is equal to or larger than 1 MiB. -1 means we
   * could not fetch the processed bytes for this query.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @com.google.api.client.json.JsonString
  private java.lang.Long processedMb;

  /**
   * True if the processed data is 0 bytes.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean zeroMb;

  /**
   * True if the processed data is less than 1 MiB.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getLessThanOneMb() {
    return lessThanOneMb;
  }

  /**
   * True if the processed data is less than 1 MiB.
   * @param lessThanOneMb lessThanOneMb or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public QueryPerformanceInfo setLessThanOneMb(java.lang.Boolean lessThanOneMb) {
    this.lessThanOneMb = lessThanOneMb;
    return this;
  }

  /**
   * MiB data this query reads. Set if the data size is equal to or larger than 1 MiB. -1 means we
   * could not fetch the processed bytes for this query.
   * @return value or {@code null} for none
   */
  public java.lang.Long getProcessedMb() {
    return processedMb;
  }

  /**
   * MiB data this query reads. Set if the data size is equal to or larger than 1 MiB. -1 means we
   * could not fetch the processed bytes for this query.
   * @param processedMb processedMb or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public QueryPerformanceInfo setProcessedMb(java.lang.Long processedMb) {
    this.processedMb = processedMb;
    return this;
  }

  /**
   * True if the processed data is 0 bytes.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getZeroMb() {
    return zeroMb;
  }

  /**
   * True if the processed data is 0 bytes.
   * @param zeroMb zeroMb or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public QueryPerformanceInfo setZeroMb(java.lang.Boolean zeroMb) {
    this.zeroMb = zeroMb;
    return this;
  }

  @Override
  public QueryPerformanceInfo set(String fieldName, Object value) {
    return (QueryPerformanceInfo) super.set(fieldName, value);
  }

  @Override
  public QueryPerformanceInfo clone() {
    return (QueryPerformanceInfo) super.clone();
  }

}
