/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * Modify at your own risk.
 */

package com.google.api.services.adsdatahub.v1.model;

/**
 * Response returned for successful query execution jobs. This is stored in the response field of
 * the google.longrunning.Operation returned by a query execution request.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Ads Data Hub API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class QueryResponse extends com.google.api.client.json.GenericJson {

  /**
   * List of output tables exported by the query.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<DestinationTableInfo> destinationTables;

  /**
   * Output artifacts generated during query execution
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private OutputArtifacts outputArtifacts;

  /**
   * List of privacy related information or warning messages.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<PrivacyMessage> privacyMessages;

  /**
   * Row count in the final output table. A wrapped value is used to distinguish between the case
   * where row count is 0 and the case where this information is not available.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @com.google.api.client.json.JsonString
  private java.lang.Long rowCount;

  /**
   * List of output tables exported by the query.
   * @return value or {@code null} for none
   */
  public java.util.List<DestinationTableInfo> getDestinationTables() {
    return destinationTables;
  }

  /**
   * List of output tables exported by the query.
   * @param destinationTables destinationTables or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public QueryResponse setDestinationTables(java.util.List<DestinationTableInfo> destinationTables) {
    this.destinationTables = destinationTables;
    return this;
  }

  /**
   * Output artifacts generated during query execution
   * @return value or {@code null} for none
   */
  public OutputArtifacts getOutputArtifacts() {
    return outputArtifacts;
  }

  /**
   * Output artifacts generated during query execution
   * @param outputArtifacts outputArtifacts or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public QueryResponse setOutputArtifacts(OutputArtifacts outputArtifacts) {
    this.outputArtifacts = outputArtifacts;
    return this;
  }

  /**
   * List of privacy related information or warning messages.
   * @return value or {@code null} for none
   */
  public java.util.List<PrivacyMessage> getPrivacyMessages() {
    return privacyMessages;
  }

  /**
   * List of privacy related information or warning messages.
   * @param privacyMessages privacyMessages or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public QueryResponse setPrivacyMessages(java.util.List<PrivacyMessage> privacyMessages) {
    this.privacyMessages = privacyMessages;
    return this;
  }

  /**
   * Row count in the final output table. A wrapped value is used to distinguish between the case
   * where row count is 0 and the case where this information is not available.
   * @return value or {@code null} for none
   */
  public java.lang.Long getRowCount() {
    return rowCount;
  }

  /**
   * Row count in the final output table. A wrapped value is used to distinguish between the case
   * where row count is 0 and the case where this information is not available.
   * @param rowCount rowCount or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public QueryResponse setRowCount(java.lang.Long rowCount) {
    this.rowCount = rowCount;
    return this;
  }

  @Override
  public QueryResponse set(String fieldName, Object value) {
    return (QueryResponse) super.set(fieldName, value);
  }

  @Override
  public QueryResponse clone() {
    return (QueryResponse) super.clone();
  }

}
