/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * Modify at your own risk.
 */

package com.google.api.services.adsdatahub.v1.model;

/**
 * Indicates ways that a query may be shared beyond the owning Ads Data Hub customer.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Ads Data Hub API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class QueryShare extends com.google.api.client.json.GenericJson {

  /**
   * Indicates how the query may be shared with other Ads Data Hub customers.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String shareType;

  /**
   * Indicates how the query may be shared with other Ads Data Hub customers.
   * @return value or {@code null} for none
   */
  public java.lang.String getShareType() {
    return shareType;
  }

  /**
   * Indicates how the query may be shared with other Ads Data Hub customers.
   * @param shareType shareType or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public QueryShare setShareType(java.lang.String shareType) {
    this.shareType = shareType;
    return this;
  }

  @Override
  public QueryShare set(String fieldName, Object value) {
    return (QueryShare) super.set(fieldName, value);
  }

  @Override
  public QueryShare clone() {
    return (QueryShare) super.clone();
  }

}
