/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * Modify at your own risk.
 */

package com.google.api.services.adsdatahub.v1.model;

/**
 * Request to remove an advertiser from a specified Ads Data Hub managed custom bidding algorithm.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Ads Data Hub API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class RemoveAdvertiserRequest extends com.google.api.client.json.GenericJson {

  /**
   * Advertiser to remove from the custom bidding algorithm
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @com.google.api.client.json.JsonString
  private java.lang.Long dv360Advertiser;

  /**
   * Advertiser to remove from the custom bidding algorithm
   * @return value or {@code null} for none
   */
  public java.lang.Long getDv360Advertiser() {
    return dv360Advertiser;
  }

  /**
   * Advertiser to remove from the custom bidding algorithm
   * @param dv360Advertiser dv360Advertiser or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public RemoveAdvertiserRequest setDv360Advertiser(java.lang.Long dv360Advertiser) {
    this.dv360Advertiser = dv360Advertiser;
    return this;
  }

  @Override
  public RemoveAdvertiserRequest set(String fieldName, Object value) {
    return (RemoveAdvertiserRequest) super.set(fieldName, value);
  }

  @Override
  public RemoveAdvertiserRequest clone() {
    return (RemoveAdvertiserRequest) super.clone();
  }

}
