/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * Modify at your own risk.
 */

package com.google.api.services.adsdatahub.v1.model;

/**
 * Request to remove recipients for a UserList.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Ads Data Hub API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class RemoveRecipientsRequest extends com.google.api.client.json.GenericJson {

  /**
   * Remove linked entities from the specified user_list’s recipients.
   * customers/[customer_id]/adsDataLinks/[resource_id]
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.lang.String> recipientAdsDataLinks;

  /**
   * Remove linked entities from the specified user_list’s recipients.
   * customers/[customer_id]/adsDataLinks/[resource_id]
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.String> getRecipientAdsDataLinks() {
    return recipientAdsDataLinks;
  }

  /**
   * Remove linked entities from the specified user_list’s recipients.
   * customers/[customer_id]/adsDataLinks/[resource_id]
   * @param recipientAdsDataLinks recipientAdsDataLinks or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public RemoveRecipientsRequest setRecipientAdsDataLinks(java.util.List<java.lang.String> recipientAdsDataLinks) {
    this.recipientAdsDataLinks = recipientAdsDataLinks;
    return this;
  }

  @Override
  public RemoveRecipientsRequest set(String fieldName, Object value) {
    return (RemoveRecipientsRequest) super.set(fieldName, value);
  }

  @Override
  public RemoveRecipientsRequest clone() {
    return (RemoveRecipientsRequest) super.clone();
  }

}
