/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * Modify at your own risk.
 */

package com.google.api.services.adsdatahub.v1.model;

/**
 * Request to start execution on a stored analysis query.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Ads Data Hub API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class StartAnalysisQueryRequest extends com.google.api.client.json.GenericJson {

  /**
   * Optional. Ads Data Hub customer executing the query. If not specified, defaults to the customer
   * that owns the query.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @com.google.api.client.json.JsonString
  private java.lang.Long customerId;

  /**
   * Destination BigQuery table for query results with the format 'project.dataset.table_name'. If
   * specified, the project must be explicitly whitelisted for the customer's ADH account. If
   * project is not specified, uses default project for the provided customer. If neither project
   * nor dataset is specified, uses the default project and dataset.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String destTable;

  /**
   * Defines the query execution parameters.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private QueryExecutionSpec spec;

  /**
   * Optional. Ads Data Hub customer executing the query. If not specified, defaults to the customer
   * that owns the query.
   * @return value or {@code null} for none
   */
  public java.lang.Long getCustomerId() {
    return customerId;
  }

  /**
   * Optional. Ads Data Hub customer executing the query. If not specified, defaults to the customer
   * that owns the query.
   * @param customerId customerId or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public StartAnalysisQueryRequest setCustomerId(java.lang.Long customerId) {
    this.customerId = customerId;
    return this;
  }

  /**
   * Destination BigQuery table for query results with the format 'project.dataset.table_name'. If
   * specified, the project must be explicitly whitelisted for the customer's ADH account. If
   * project is not specified, uses default project for the provided customer. If neither project
   * nor dataset is specified, uses the default project and dataset.
   * @return value or {@code null} for none
   */
  public java.lang.String getDestTable() {
    return destTable;
  }

  /**
   * Destination BigQuery table for query results with the format 'project.dataset.table_name'. If
   * specified, the project must be explicitly whitelisted for the customer's ADH account. If
   * project is not specified, uses default project for the provided customer. If neither project
   * nor dataset is specified, uses the default project and dataset.
   * @param destTable destTable or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public StartAnalysisQueryRequest setDestTable(java.lang.String destTable) {
    this.destTable = destTable;
    return this;
  }

  /**
   * Defines the query execution parameters.
   * @return value or {@code null} for none
   */
  public QueryExecutionSpec getSpec() {
    return spec;
  }

  /**
   * Defines the query execution parameters.
   * @param spec spec or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public StartAnalysisQueryRequest setSpec(QueryExecutionSpec spec) {
    this.spec = spec;
    return this;
  }

  @Override
  public StartAnalysisQueryRequest set(String fieldName, Object value) {
    return (StartAnalysisQueryRequest) super.set(fieldName, value);
  }

  @Override
  public StartAnalysisQueryRequest clone() {
    return (StartAnalysisQueryRequest) super.clone();
  }

}
