/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * Modify at your own risk.
 */

package com.google.api.services.adsdatahub.v1.model;

/**
 * A key-value pair that defines a single struct field.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Ads Data Hub API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class StructField extends com.google.api.client.json.GenericJson {

  /**
   * Field name.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String fieldName;

  /**
   * Field type.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private FieldType fieldType;

  /**
   * Field name.
   * @return value or {@code null} for none
   */
  public java.lang.String getFieldName() {
    return fieldName;
  }

  /**
   * Field name.
   * @param fieldName fieldName or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public StructField setFieldName(java.lang.String fieldName) {
    this.fieldName = fieldName;
    return this;
  }

  /**
   * Field type.
   * @return value or {@code null} for none
   */
  public FieldType getFieldType() {
    return fieldType;
  }

  /**
   * Field type.
   * @param fieldType fieldType or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public StructField setFieldType(FieldType fieldType) {
    this.fieldType = fieldType;
    return this;
  }

  @Override
  public StructField set(String fieldName, Object value) {
    return (StructField) super.set(fieldName, value);
  }

  @Override
  public StructField clone() {
    return (StructField) super.clone();
  }

}
