/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * Modify at your own risk.
 */

package com.google.api.services.adsdatahub.v1.model;

/**
 * Request to submit a Vendor Metric Summary report.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Ads Data Hub API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class SubmitVendorAggregatesReportRequest extends com.google.api.client.json.GenericJson {

  /**
   * Required. Ads Data Hub customer making the request. This is in the form of
   * 'customers/[customer_id]'. e.g. 'customers/123'.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String customer;

  /**
   * Required. Date (either in vendor-wide time zone or per-row time zone) for the report.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Date date;

  /**
   * Required. Metric which the table is reporting.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String metric;

  /**
   * Required. Source BigQuery table for query results in the format 'project.dataset.table_name'.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String sourceTable;

  /**
   * Required. Ads Data Hub customer making the request. This is in the form of
   * 'customers/[customer_id]'. e.g. 'customers/123'.
   * @return value or {@code null} for none
   */
  public java.lang.String getCustomer() {
    return customer;
  }

  /**
   * Required. Ads Data Hub customer making the request. This is in the form of
   * 'customers/[customer_id]'. e.g. 'customers/123'.
   * @param customer customer or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public SubmitVendorAggregatesReportRequest setCustomer(java.lang.String customer) {
    this.customer = customer;
    return this;
  }

  /**
   * Required. Date (either in vendor-wide time zone or per-row time zone) for the report.
   * @return value or {@code null} for none
   */
  public Date getDate() {
    return date;
  }

  /**
   * Required. Date (either in vendor-wide time zone or per-row time zone) for the report.
   * @param date date or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public SubmitVendorAggregatesReportRequest setDate(Date date) {
    this.date = date;
    return this;
  }

  /**
   * Required. Metric which the table is reporting.
   * @return value or {@code null} for none
   */
  public java.lang.String getMetric() {
    return metric;
  }

  /**
   * Required. Metric which the table is reporting.
   * @param metric metric or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public SubmitVendorAggregatesReportRequest setMetric(java.lang.String metric) {
    this.metric = metric;
    return this;
  }

  /**
   * Required. Source BigQuery table for query results in the format 'project.dataset.table_name'.
   * @return value or {@code null} for none
   */
  public java.lang.String getSourceTable() {
    return sourceTable;
  }

  /**
   * Required. Source BigQuery table for query results in the format 'project.dataset.table_name'.
   * @param sourceTable sourceTable or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public SubmitVendorAggregatesReportRequest setSourceTable(java.lang.String sourceTable) {
    this.sourceTable = sourceTable;
    return this;
  }

  @Override
  public SubmitVendorAggregatesReportRequest set(String fieldName, Object value) {
    return (SubmitVendorAggregatesReportRequest) super.set(fieldName, value);
  }

  @Override
  public SubmitVendorAggregatesReportRequest clone() {
    return (SubmitVendorAggregatesReportRequest) super.clone();
  }

}
