/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * Modify at your own risk.
 */

package com.google.api.services.adsdatahub.v1.model;

/**
 * Metadata for Customer Report ID Mapping submission request associated with each operation.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Ads Data Hub API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class SubmitVendorReportIdMappingMetadata extends com.google.api.client.json.GenericJson {

  /**
   * Import end time.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String endTime;

  /**
   * Request for Brand Safety Scores submission.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private SubmitVendorReportIdMappingRequest request;

  /**
   * Import start time.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String startTime;

  /**
   * Import end time.
   * @return value or {@code null} for none
   */
  public String getEndTime() {
    return endTime;
  }

  /**
   * Import end time.
   * @param endTime endTime or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public SubmitVendorReportIdMappingMetadata setEndTime(String endTime) {
    this.endTime = endTime;
    return this;
  }

  /**
   * Request for Brand Safety Scores submission.
   * @return value or {@code null} for none
   */
  public SubmitVendorReportIdMappingRequest getRequest() {
    return request;
  }

  /**
   * Request for Brand Safety Scores submission.
   * @param request request or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public SubmitVendorReportIdMappingMetadata setRequest(SubmitVendorReportIdMappingRequest request) {
    this.request = request;
    return this;
  }

  /**
   * Import start time.
   * @return value or {@code null} for none
   */
  public String getStartTime() {
    return startTime;
  }

  /**
   * Import start time.
   * @param startTime startTime or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public SubmitVendorReportIdMappingMetadata setStartTime(String startTime) {
    this.startTime = startTime;
    return this;
  }

  @Override
  public SubmitVendorReportIdMappingMetadata set(String fieldName, Object value) {
    return (SubmitVendorReportIdMappingMetadata) super.set(fieldName, value);
  }

  @Override
  public SubmitVendorReportIdMappingMetadata clone() {
    return (SubmitVendorReportIdMappingMetadata) super.clone();
  }

}
