/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * Modify at your own risk.
 */

package com.google.api.services.adsdatahub.v1.model;

/**
 * Defines a table that can be queried.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Ads Data Hub API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Table extends com.google.api.client.json.GenericJson {

  /**
   * A list of table columns.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Column> columns;

  /**
   * Name that uniquely identifies a table. It has the form
   * customers/[customer_id]/tables/[table_path], e.g.
   * 'customers/123/tables/adh.google_ads_impressions'.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String name;

  /**
   * Fully qualified table path, e.g. 'adh.google_ads_impressions'.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String tablePath;

  /**
   * A list of table columns.
   * @return value or {@code null} for none
   */
  public java.util.List<Column> getColumns() {
    return columns;
  }

  /**
   * A list of table columns.
   * @param columns columns or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public Table setColumns(java.util.List<Column> columns) {
    this.columns = columns;
    return this;
  }

  /**
   * Name that uniquely identifies a table. It has the form
   * customers/[customer_id]/tables/[table_path], e.g.
   * 'customers/123/tables/adh.google_ads_impressions'.
   * @return value or {@code null} for none
   */
  public java.lang.String getName() {
    return name;
  }

  /**
   * Name that uniquely identifies a table. It has the form
   * customers/[customer_id]/tables/[table_path], e.g.
   * 'customers/123/tables/adh.google_ads_impressions'.
   * @param name name or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public Table setName(java.lang.String name) {
    this.name = name;
    return this;
  }

  /**
   * Fully qualified table path, e.g. 'adh.google_ads_impressions'.
   * @return value or {@code null} for none
   */
  public java.lang.String getTablePath() {
    return tablePath;
  }

  /**
   * Fully qualified table path, e.g. 'adh.google_ads_impressions'.
   * @param tablePath tablePath or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public Table setTablePath(java.lang.String tablePath) {
    this.tablePath = tablePath;
    return this;
  }

  @Override
  public Table set(String fieldName, Object value) {
    return (Table) super.set(fieldName, value);
  }

  @Override
  public Table clone() {
    return (Table) super.clone();
  }

}
