/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * Modify at your own risk.
 */

package com.google.api.services.adsdatahub.v1.model;

/**
 * Defines a user list query that can be executed within Ads Data Hub.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Ads Data Hub API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class UserListQuery extends com.google.api.client.json.GenericJson {

  /**
   * Email address of user who created the query.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String createEmail;

  /**
   * Time the query was created.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String createTime;

  /**
   * Name that uniquely identifies a query. It has the form
   * customers/[customer_id]/userListQueries/[resource_id], e.g.
   * 'customers/123/userListQueries/abcd1234'. The resource ID is generated by the server.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String name;

  /**
   * Any additional parameters expected by the query. Maps each argument name to its argument type.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.Map<String, ParameterType> parameterTypes;

  static {
    // hack to force ProGuard to consider ParameterType used, since otherwise it would be stripped out
    // see https://github.com/google/google-api-java-client/issues/543
    com.google.api.client.util.Data.nullOf(ParameterType.class);
  }

  /**
   * Indicates ways that a query may be shared beyond the owning Ads Data Hub customer.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<QueryShare> queryShare;

  static {
    // hack to force ProGuard to consider QueryShare used, since otherwise it would be stripped out
    // see https://github.com/google/google-api-java-client/issues/543
    com.google.api.client.util.Data.nullOf(QueryShare.class);
  }

  /**
   * Query state.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String queryState;

  /**
   * Query text.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String queryText;

  /**
   * Query title, which is unique within a single Ads Data Hub customer and query type.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String title;

  /**
   * Email address of user who last updated the query.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String updateEmail;

  /**
   * Time the query was last updated.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String updateTime;

  /**
   * Output only. The Ads Data Hub user list resource that can be populated by this user list query.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.lang.String> userList;

  /**
   * Email address of user who created the query.
   * @return value or {@code null} for none
   */
  public java.lang.String getCreateEmail() {
    return createEmail;
  }

  /**
   * Email address of user who created the query.
   * @param createEmail createEmail or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public UserListQuery setCreateEmail(java.lang.String createEmail) {
    this.createEmail = createEmail;
    return this;
  }

  /**
   * Time the query was created.
   * @return value or {@code null} for none
   */
  public String getCreateTime() {
    return createTime;
  }

  /**
   * Time the query was created.
   * @param createTime createTime or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public UserListQuery setCreateTime(String createTime) {
    this.createTime = createTime;
    return this;
  }

  /**
   * Name that uniquely identifies a query. It has the form
   * customers/[customer_id]/userListQueries/[resource_id], e.g.
   * 'customers/123/userListQueries/abcd1234'. The resource ID is generated by the server.
   * @return value or {@code null} for none
   */
  public java.lang.String getName() {
    return name;
  }

  /**
   * Name that uniquely identifies a query. It has the form
   * customers/[customer_id]/userListQueries/[resource_id], e.g.
   * 'customers/123/userListQueries/abcd1234'. The resource ID is generated by the server.
   * @param name name or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public UserListQuery setName(java.lang.String name) {
    this.name = name;
    return this;
  }

  /**
   * Any additional parameters expected by the query. Maps each argument name to its argument type.
   * @return value or {@code null} for none
   */
  public java.util.Map<String, ParameterType> getParameterTypes() {
    return parameterTypes;
  }

  /**
   * Any additional parameters expected by the query. Maps each argument name to its argument type.
   * @param parameterTypes parameterTypes or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public UserListQuery setParameterTypes(java.util.Map<String, ParameterType> parameterTypes) {
    this.parameterTypes = parameterTypes;
    return this;
  }

  /**
   * Indicates ways that a query may be shared beyond the owning Ads Data Hub customer.
   * @return value or {@code null} for none
   */
  public java.util.List<QueryShare> getQueryShare() {
    return queryShare;
  }

  /**
   * Indicates ways that a query may be shared beyond the owning Ads Data Hub customer.
   * @param queryShare queryShare or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public UserListQuery setQueryShare(java.util.List<QueryShare> queryShare) {
    this.queryShare = queryShare;
    return this;
  }

  /**
   * Query state.
   * @return value or {@code null} for none
   */
  public java.lang.String getQueryState() {
    return queryState;
  }

  /**
   * Query state.
   * @param queryState queryState or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public UserListQuery setQueryState(java.lang.String queryState) {
    this.queryState = queryState;
    return this;
  }

  /**
   * Query text.
   * @return value or {@code null} for none
   */
  public java.lang.String getQueryText() {
    return queryText;
  }

  /**
   * Query text.
   * @param queryText queryText or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public UserListQuery setQueryText(java.lang.String queryText) {
    this.queryText = queryText;
    return this;
  }

  /**
   * Query title, which is unique within a single Ads Data Hub customer and query type.
   * @return value or {@code null} for none
   */
  public java.lang.String getTitle() {
    return title;
  }

  /**
   * Query title, which is unique within a single Ads Data Hub customer and query type.
   * @param title title or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public UserListQuery setTitle(java.lang.String title) {
    this.title = title;
    return this;
  }

  /**
   * Email address of user who last updated the query.
   * @return value or {@code null} for none
   */
  public java.lang.String getUpdateEmail() {
    return updateEmail;
  }

  /**
   * Email address of user who last updated the query.
   * @param updateEmail updateEmail or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public UserListQuery setUpdateEmail(java.lang.String updateEmail) {
    this.updateEmail = updateEmail;
    return this;
  }

  /**
   * Time the query was last updated.
   * @return value or {@code null} for none
   */
  public String getUpdateTime() {
    return updateTime;
  }

  /**
   * Time the query was last updated.
   * @param updateTime updateTime or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public UserListQuery setUpdateTime(String updateTime) {
    this.updateTime = updateTime;
    return this;
  }

  /**
   * Output only. The Ads Data Hub user list resource that can be populated by this user list query.
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.String> getUserList() {
    return userList;
  }

  /**
   * Output only. The Ads Data Hub user list resource that can be populated by this user list query.
   * @param userList userList or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public UserListQuery setUserList(java.util.List<java.lang.String> userList) {
    this.userList = userList;
    return this;
  }

  @Override
  public UserListQuery set(String fieldName, Object value) {
    return (UserListQuery) super.set(fieldName, value);
  }

  @Override
  public UserListQuery clone() {
    return (UserListQuery) super.clone();
  }

}
