/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * Modify at your own risk.
 */

package com.google.api.services.adsdatahub.v1.model;

/**
 * Response to a ValidateUserListQuery request.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Ads Data Hub API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class ValidateUserListQueryResponse extends com.google.api.client.json.GenericJson {

  /**
   * Deprecated, and use query_performance_info instead. Bytes of data this query reads. See
   * https://cloud.google.com/bigquery/pricing#data for details on how this is calculated. Returned
   * if include_performance_info is true. We round the processed_bytes to MB, and then convert it to
   * bytes. -1 means we couldn't fetch it for this query.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @com.google.api.client.json.JsonString
  private java.lang.Long processedBytes;

  /**
   * Returned if include_performance_info is true.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private QueryPerformanceInfo queryPerformanceInfo;

  /**
   * Deprecated, and use query_performance_info instead. Bytes of data this query reads. See
   * https://cloud.google.com/bigquery/pricing#data for details on how this is calculated. Returned
   * if include_performance_info is true. We round the processed_bytes to MB, and then convert it to
   * bytes. -1 means we couldn't fetch it for this query.
   * @return value or {@code null} for none
   */
  public java.lang.Long getProcessedBytes() {
    return processedBytes;
  }

  /**
   * Deprecated, and use query_performance_info instead. Bytes of data this query reads. See
   * https://cloud.google.com/bigquery/pricing#data for details on how this is calculated. Returned
   * if include_performance_info is true. We round the processed_bytes to MB, and then convert it to
   * bytes. -1 means we couldn't fetch it for this query.
   * @param processedBytes processedBytes or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public ValidateUserListQueryResponse setProcessedBytes(java.lang.Long processedBytes) {
    this.processedBytes = processedBytes;
    return this;
  }

  /**
   * Returned if include_performance_info is true.
   * @return value or {@code null} for none
   */
  public QueryPerformanceInfo getQueryPerformanceInfo() {
    return queryPerformanceInfo;
  }

  /**
   * Returned if include_performance_info is true.
   * @param queryPerformanceInfo queryPerformanceInfo or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public ValidateUserListQueryResponse setQueryPerformanceInfo(QueryPerformanceInfo queryPerformanceInfo) {
    this.queryPerformanceInfo = queryPerformanceInfo;
    return this;
  }

  @Override
  public ValidateUserListQueryResponse set(String fieldName, Object value) {
    return (ValidateUserListQueryResponse) super.set(fieldName, value);
  }

  @Override
  public ValidateUserListQueryResponse clone() {
    return (ValidateUserListQueryResponse) super.clone();
  }

}
