/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * Modify at your own risk.
 */

package com.google.api.services.adsdatahub.v1.model;

/**
 * Filtering dimensions for YouTube Reserve platform.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Ads Data Hub API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class YouTubeReserveDimensions extends com.google.api.client.json.GenericJson {

  /**
   * Designates the platform to measure and report on.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String metricType;

  /**
   * Optional YouTube Reserve order ids. If empty, reports on all orders for the specified time
   * period.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @com.google.api.client.json.JsonString
  private java.util.List<java.lang.Long> orderIds;

  /**
   * Designates the platform to measure and report on.
   * @return value or {@code null} for none
   */
  public java.lang.String getMetricType() {
    return metricType;
  }

  /**
   * Designates the platform to measure and report on.
   * @param metricType metricType or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public YouTubeReserveDimensions setMetricType(java.lang.String metricType) {
    this.metricType = metricType;
    return this;
  }

  /**
   * Optional YouTube Reserve order ids. If empty, reports on all orders for the specified time
   * period.
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.Long> getOrderIds() {
    return orderIds;
  }

  /**
   * Optional YouTube Reserve order ids. If empty, reports on all orders for the specified time
   * period.
   * @param orderIds orderIds or {@code null} for none
   */
  @com.google.errorprone.annotations.CanIgnoreReturnValue
  public YouTubeReserveDimensions setOrderIds(java.util.List<java.lang.Long> orderIds) {
    this.orderIds = orderIds;
    return this;
  }

  @Override
  public YouTubeReserveDimensions set(String fieldName, Object value) {
    return (YouTubeReserveDimensions) super.set(fieldName, value);
  }

  @Override
  public YouTubeReserveDimensions clone() {
    return (YouTubeReserveDimensions) super.clone();
  }

}
